                  THE AMERICAN ANIMATION INSTITUTE
                      4729 Lankershim Boulevard
                   North Hollywood, CA 91602-1864
                           (818) 766-0521

                  ---------------------------------
                  1987 CATALOGUE AND CLASS SCHEDULE
                  ---------------------------------

               Spring Semester (February 23 - May 11)
                Summer Semester (June 1 - August 25)
             Fall Semester (September 14 - December 15)

The American Animation Institute was founded in 1980 by the Motion Picture
Screen Cartoonists, Local 839 I.  A.  T.  S.  E., to further the art of the
animated cartoon in the United States through educational and other activities.

WHY THE AMERICAN ANIMATION INSTITUTE?  Cartoon animation in the United States
is at a crisis point.  The classic animators of the "golden age of animation"
have almost all retired, and too many of the greats have passed away.  Few
attempts have been made to pass the wealth of these artists' knowledge to a new
generation.

Within the last twenty years, most of those who have entered the screen
cartooning industry in creative and artistic job categories have received
little or no professional instruction in the "nuts and bolts" of the art.  Few
animation studios are willing or able to offer their apprentices any real
training, and there has been no real means for screen cartoonists to brush up
their skills.  The American Animation Institute is attempting to bridge that
gap.

In addition to our classes geared to industry professionals, the Institute
offers introductory and intermediate classes for persons without previous
professional experience who are seeking their first jobs in screen cartooning.
The two introductory seminars, Introduction to the Art and Industry and Basic
Animation Mechanics, run for three consecutive weeks, one two-hour session per
week.  Most of the Institute's other classes run for twelve weeks, one night a
week.

All of the Institute's classes are offered at the M.  P.  S.  C.  Local 839
headquarters building at 4729 Lankershim Boulevard in North Hollywood,
California.  Our facilities include two classrooms, an animation work room
equipped with lightboards and facilities for viewing pencil tests, and a
fully-equipped studio classroom for painting and drawing classes.

Our animation classes utilize the NAC Quick Action Recorder, a revolutionary
computerized animation pencil-test system that enables animation students to
see their rough animation tests within minutes after they have have been drawn.

With the QAR system, students can shoot their own pencil tests during class
time, and can instantaneously judge the effect of timing changes and drawing
alterations.  The Institiute is the only educational organization in the United
States using this equipment.

SO YOU WANT TO BE A CARTOONIST ...  Persons without previous professional
experience in screen cartooning are required to take Introduction to the Art
and Industry and Basic Animation Mechanics as prerequisites for all other
industry classes.  However, neither these nor any other classes offered by the
American Animation Institute are either a guarantee or a prerequisite for
employment.  Although many graduates of Institute classes have gone on to
careers in screen cartooning, the Institute is not a placement service and
cannot recommend students to specific employers.

High-school graduates should be aware that most employers in this field require
some form of junior-college or college level art training as a prerequisite for
employment.  The Institute encourages college students to take its classes
concurrently with their other studies.

CLASS REBATES:  Active members in good standing of M.  P.  S.  C.  Local 839
qualify for a rebate of $20.00 on twelve-week classes.  In order to receive a
rebate you must attend at least ten of the twelve class sessions.  Rebates will
be mailed within a week after the last class session.

REGISTRATION:  Reservations for upcoming classes will be accepted by mail, by
phone or in person.  Reservations can only be taken for the next upcoming
scheduled class session.

After you have registered and shortly before the class is scheduled to begin,
you will be sent a postcard confirming that the class is to be held.  This card
must be returned with payment in full to complete your registration and reserve
your place in the class.  Local 839 members will be given registration priority
only if they have paid in full before the first class session.  Your
reservation for the class is not confirmed until you have paid in full.

The Institute reserves the right to cancel a class at any time before the first
scheduled class session.  If the class has been cancelled, your name will be
kept on file and you will be informed of any future scheduled class sessions.
Any money collected for a cancelled class will be refunded in full.

Unless otherwise listed, all classes run from 7 pm to 9 pm.  The building is
opened at 6:45 pm Monday through Wednesday, and 6:15 pm on Thursday.

For further information on registration, contact the Institute.  The office is
open weekdays from 8 am to 5 pm.

------------------------------------------------------------------

                        =====================
                        INTRODUCTORY SEMINARS
                        =====================

INTRODUCTION TO THE ART AND INDUSTRY 3 Tuesdays, January 6, 13, 20
Bud Hester                                February 24, March 3, 10
                                                  April 14, 21, 28
Fee: $30.00                                          June 2, 9, 16
                                                  August 4, 11, 18
                                                 October 6, 13, 20

An overview of screen cartooning in Los Angeles County.  The nature of this
challenging (and often exasperating!) field is discussed.  A realistic
appraisal is given of current employment possibilities in entry-level job
positions.  The union and its purpose and function in relation to employers and
workers are explained, to show that union membership and industry employment
are not a "catch-22" for the prospective screen cartoonist.  For the final
class session, students prepare portfolios to be submitted and reviewed in
class by the instructor, who will give personal advice on presenting to a
potential employer the skills necessary for employment.

------------------------------------------------------------------

BASIC ANIMATION MECHANICS           3 Tuesdays, February 3, 10, 17
Bud Hester                                   March 17, 24, April 7
                                                     May 5, 12, 19
Fee: $30.00                                    June 23, 30, July 7
                                         August 25, September 1, 8
                                        October 27, November 3, 10

Prerequisite:  Introduction to the Art and Industry, or membership in Local 839
IATSE.  Reservations will not be taken for this class until after the
immediately preceding session of Introduction to the Art and Industry has
begun.

All persons working in screen cartooning, whether in creative, rendering or
technical job categories, are required to understand certain technical aspects
of the animation process.  This class covers the functions and capabilities of
the animation camera; the use of animation bars and peg systems with tilts and
pans; the composition and reading of the exposure sheet; and the flipping,
rolling and stacking of drawings by the animator in in preparation for the work
of the assistant animator, the clean-up artist and inbetweener.


------------------------------------------------------------------

                     ===========================
                     TRAINING CLASSES: ANIMATION
                     ===========================

INBETWEENING                       12 Tuesdays, February 24-May 12
Dale Oliver                                       June 2-August 18
Fee: $70.00*                               September 15-December 1

Prerequisite: Basic Animation Mechanics, or membership in Local 839 IATSE.

This class covers the working duties of the inbetweener, the apprentice
assistant animator who fleshes out the movement of the animated sequence by
providing "in-between" drawings as specified by the animator and his assistant.

Students work during class time at inbetweening animated sequences, using
supplies and equipment provided by the Institute.

------------------------------------------------------------------

ASSISTANT ANIMATION               12 Thursdays, February 26-May 14
Dave Brain                                        June 4-August 20
Fee: $70.00*                              September 17-December 10

Prerequisite:  The Inbetweening class, or membership in Local 839 IATSE.

This class will focus on choosing drawings to be keyed, following and
interpreting model sheets, and putting characters on model without losing the
animator's action or expression.  Strong emphasis on improving drawing skills
and line quality.

------------------------------------------------------------------

ANIMATION                           12 Mondays, February 23-May 11
Clair Weeks                                       June 1-August 17
Fee: $70.00*                              September 14-November 30

Prerequisite:  The Assistant Animation class, or membership experience in Local
839 IATSE as an animator, assistant animator or inbetweener.

Emphasis in this course will be placed on strong, descriptive poses, clear
staging, a detailed study of dialogue and the acting involved in character
animation.  Further refinement in the theories of timing will also be
emphasized.

Students should be prepared to do homework assignments using their own supplies
and equipment.  These assignments will be photographed at the Institute using
the NAC Quick Action Recorder, and will be critiqued in class.

------------------------------------------------------------------

                 ===================================
                 TRAINING CLASSES: CARTOONIST CRAFTS
                 ===================================

BACKGROUND PAINTING AND DESIGN      12 Mondays, February 23-May 11
Jeff Richards                                     June 1-August 17
Fee: $70.00*                              September 14-November 30

Prerequisite for non-members of Local 839 IATSE: Basic Animation Mechanics.

------------------------------------------------------------------

LAYOUT                            12 Thursdays, February 26-May 14
instructor TBA                                    June 4-August 20
Fee: $70.00*                              September 17-December 10

Prerequisite for non-members of Local 839 IATSE: Basic Animation Mechanics.

------------------------------------------------------------------

MODEL DESIGN                        12 Mondays, February 23-May 11
Bob Singer                                        June 1-August 17
Fee: $70.00*                              September 14-November 30

Prerequisite for non-members of Local 839 IATSE: Basic Animation Mechanics.

------------------------------------------------------------------

STORYBOARDING                    12 Wednesdays, February 25-May 13
Scott Shaw                                        June 3-August 19
Fee: $70.00*                               September 16-December 2

Prerequisite for non-members of Local 839 IATSE: Basic Animation Mechanics.

------------------------------------------------------------------

ADVANCED STORYBOARDING           12 Wednesdays, February 25-May 13
Gary Hoffman                                      June 3-August 19
Fee: $70.00*                               September 16-December 2

Prerequisite: The Storyboarding class, or membership in Local 839 IATSE as a
storyboard artist.

------------------------------------------------------------------

ANIMATION CHECKING               12 Wednesdays, February 25-May 13
Cindy Goode                                       June 3-August 19
Fee: $70.00*                               September 16-December 2

Prerequisite for non-members of Local 839 IATSE: Basic Animation Mechanics.

------------------------------------------------------------------

                             ===========
                             ART CLASSES
                             ===========

LIFE DRAWING                       12 Tuesdays, February 24-May 19
Glenn Vilppu                                      June 2-August 25
Fee: $85.00*                              September 15-December 15
7 pm-10 pm

Note: no class held on March 31, July 28, September 29 or November 24.

------------------------------------------------------------------

PAINTING: ACRYLICS AND OILS       12 Thursdays, February 26-May 14
Hal Kramer                                        June 4-August 20
Fee: $95.00*                              September 17-December 10
6:30 pm-9:30 pm

------------------------------------------------------------------

* Members of Local 839 IATSE taking this class are eligible for class rebates.
See above.

For further information about the Institute or Local 839 IATSE, leave an
message on the Litforumfor Jeff Massie 76474,1326.  To register for classes,
contact the Institute at the address and phone number above.

