---------------------------------------
			      FAST LANE MODEMS,
		 Typed in from this months Popular Science
			      by: Candy Apple
				  10-27-85

The words raced across the IBM PC's screen in a blur.  Line after line of the
20,000 word document scrolled rapidly from the bottom to the top of the display
in a gray haze.

Barely two minutes after an amazing new modem had automatically dialed a number
using standard telephone lines, it finished transmitting the document with no
erors.	A message popped up on th PC's screen:  14323 bps.  The transmission
speed for the test document was 48 times faster than that of the 300 bps modems
most often used for personal computer communications.

Another example of Trailblazer's mercurial speed:  When I trasmitted this
article from my Los Angeles offices to the PS editorial offices in New York
using my old 1200 bps modem, it took a minute and a half, ending up at the
receiveing end with a dozen erorrs because of line noise.  With the
Trailblazer, I could have done it error free in less than 10 seconds.

After witnessing a demonstration at Telebit's headquarters in Cupertino,
Calif., I feel certain that the company's new scheme for transferring data over
normal phone lines will spark a trend in computer communications.  The patented
technology, which is capable of transmitting at more then 21000 bps, puts
existing modems incluing the new 2400 bps units into the same category as a
Ford Model T on a freeway.  You'll pay a premuim for the high performance:
1995 for a curcuit board version that plugs into the IBM PC's and similiar
machines, and 2395 for a standalone unit compatible with most other personal
computers.  The Modems are also marketed by Digital Communications Associates
under the name Fastlink.

The innovative modem will make a variety of new microcomputer applications
possible:

Fast transfer of entire screens of data between computers, particularly useful
for transmitting complete spread sheet documents without errors.

Transmissioon of high quality photographs, charts, and graphs in either
monochrome or color.

Micro to main frame computer communications at speeds fast enough to make
efficient use of the larger computers time.

Sending software in minutes from commercial data bases to remote buyers.

Transmitting extremely long documents such as lawyer's briefs, trial records,
and manuscripts.

Getting the latest wares off Ae lines in a matter of minutes.

Permitting, eventually, both voice and data to share a single phone line,
opening high speed commercial data networks to individual users.

Telebit's modem achieves ultra high speed error free transmission by treating
data differently than standard modems do.  And Trailblazer requires a good deal
of onboard computing power--a Motorola 68000 microprocessor and a Texas
Instruments TMS 320 signal processor--to do so.  The processing enables the
modem to ignore crackels, pops, static, dialing clicks, CALL-WAITING TONES, and
any other telephone line interference.

"High speed is important," says Telebit chairman Paul Baran, who conceived and
developed the new style communications.  "But the most important element in
this modem is that it always works, no matter how bad the telephone line is."

That's critical.  Since telephone deregulation and he breakup of the Bell
System, the quality of U.S.  voice telephone lines has been deteriorating.
Individual phone companies and long distance carriers are packing more calls
into circuits, and audible interference is increasing.	That bodes ill for
computer communications.  Even at 300 or 1200 bps, phone lines must be
relatively noiseless to avoid transmission errors.  "The need is for a modem
that works with rotten telephone lines," Baran says.  "The questions is, is it
possible to build a data communications device tht will work on any line short
of a wet piece of spaghetti?"

Techniques other than those used in standard modems allow main frame computer
to transmit at speeds of more than two million bps without errors.  At Rand
Corp.  in the early 1960s, Baran developed packet switching, a method for high
speed error free communications between main frame computers in which data is
conveyed in fixed size blocks, or packets.  Each packet contains checking codes
to eliminate transmisson errors caused by line noise or other interference.

Baran's earlier work led him to devise a new concept in microcomputer modems:
If many tones across the entire phone line frequency spectrum (or bandwidth)
could be modulated rather than just a few tones as in standard modems, much
higher speeds would be possible.  The problem would become how to identify the
parts of the bandwidth that are garbled by interference.  Working with a small
team of experts, Baran solved the problem.  he built a modem that samples
telephone line quality and then computes the best available speed for sending
data.

Here's how Trailblazer works:  When two modems are connected, the originating
unit sends a burst of 512 simultaneous tones, equally spaced in frequency from
about 500 to 3600 hertz (cycles per second), followed by a moment of silence.
The receiveing modem evaluates each tone's quality and identifies which
frequencies are clear enough to handle data.  In the null period, it measures
overall line noise to calculate a signal to noise ratio.  Next, Trailblazers
processors determine whether signal strength of each available tone will allow
two, four, or six bits to be send (through modulation coding) on each tone.
This is where data packets come into play.  If 400 tones are clear for six bit
modulation, a single data packet will contain 2400 bits.  Some of those bits
will be used for error checking and for continuous monnitoring of tone quality,
and line quality.  About 20 percent of each packet is used for such "overhead"
duties.  Finally, still less than one second after the initial connection, data
transfer begins.

The originating modem receives data from the personal computer converts the
data at a rate of seven packets per second, and transmits it through the phone
line.  At the receiving end, an identical Trailblazer reverses the process.  In
this case, seven packets per second multiplied by 2400 bits yield 16800
bps--with more than 13000 bits of that total being the user's data.  If
interference disrupts any packet, the receiving modem monitors the error and
asks for the packet to be resent.  Should the interference continue, the modems
would recompute their tone scheme to eliminate bad frequencies.

In extensive testing, Baran says, the worst phone line they found still handled
about 5000 bps.  Average long distance rates exceed 10000 bps,

About 20 percent of each packet is used for such "overhead" duties.  Finally,
still less than one second after the initial connection, data transfer begins.

The originating modem receives data from the personal computer converts the
data at a rate of seven packets per second, and transmits it through the phone
line.  At the receiving end, an identical Trailblazer reverses the process.  In
this case, seven packets per second multiplied by 2400 bits yield 16800
bps--with more than 13000 bits of that total being the user's data.  If
interference disrupts any packet, the receiving modem monitors the error and
asks for the packet to be resent.  Should the interference continue, the modems
would recompute their tone scheme to eliminate bad frequencies.

In extensive testing, Baran says, the worst phone line they found still handled
about 5000 bps.  Average long distance rates exceed 10000 bps, with local calls
attaining higher speeds.  Of course, the Trailblazer won't always have one of
its counterparts to talk to, so each is designed to emulate standard 300 and
1200 bps modems.

=== END OF FILE ===
---------------------------------------
[][][][][][][][][][][][][][][][][][][]
  The Fifth Precinct..[502] 245-8270
[][][][][][][][][][][][][][][][][][][]
